\section{Answer Set Programming}
An \textbf{answer set} is the set of all atoms entailed by a KB.
To compute these sets we focus on minimal models.
However some models make less sense than others, e.g. consider
\begin{align*}
  p &\Leftarrow p \\
  q &\Leftarrow \operatorname{not}(P)
\end{align*}
then there are two minimal models $\{q\}$, and $\{p\}$.
However, the last is not ``grounded'' i.e. it is not based on any prior fact.
Hence we introduce the notion of stable models:

\highlightbox{Reducts \& Stable models}{
  Let $I = \langle D, \Phi\rangle$ be an interpretation and KB a knowledge base.
  Then for every atom $q$ that is fulfilled by $I$ remove any rule with $\operatorname{not} (q)$ in its body.
  Finally remove all occurences of $\operatorname{not}(q)$ for all atoms $q$ that are not fulfilled by $I$.
  The altered version of KB is then called the \textbf{Reduct} of KB w.r.t. $I$. \\

  $I$ is called a stable model iff it is the minimal model of KB w.r.t. itself.
}
